#ifndef seafire__protocol__read_content_hxx_
#define seafire__protocol__read_content_hxx_

#include <seafire/protocol/request.hxx>
#include <seafire/protocol/response.hxx>

#include <seafire/common/io/stream.hxx>

namespace seafire::protocol
{

  void
  read_content(common::io::stream_t&,
               asio::streambuf&,
               asio::streambuf&,
               std::size_t);

  void
  read_content(common::io::stream_t&,
               asio::streambuf&,
               asio::streambuf&,
               std::size_t,
               std::error_code&);

  void
  async_read_content(common::io::stream_t&,
                     asio::streambuf&,
                     asio::streambuf&,
                     std::size_t,
                     std::function<void(std::error_code)>);

  void
  read_content(common::io::stream_t&,
               asio::streambuf&,
               asio::streambuf&,
               request_t const&);

  void
  read_content(common::io::stream_t&,
               asio::streambuf&,
               asio::streambuf&,
               request_t const&,
               std::error_code&);

  void
  async_read_content(common::io::stream_t&,
                     asio::streambuf&,
                     asio::streambuf&,
                     request_t const&,
                     std::function<void(std::error_code)>);

  void
  read_content(common::io::stream_t&,
               asio::streambuf&,
               asio::streambuf&,
               response_t const&);

  void
  read_content(common::io::stream_t&,
               asio::streambuf&,
               asio::streambuf&,
               response_t const&,
               std::error_code&);

  void
  async_read_content(common::io::stream_t&,
                     asio::streambuf&,
                     asio::streambuf&,
                     response_t const&,
                     std::function<void(std::error_code)>);

} // namespace seafire::protocol

#endif
