#ifndef seafire__protocol__read_hxx_
#define seafire__protocol__read_hxx_

#include <seafire/protocol/message.hxx>
#include <seafire/protocol/request.hxx>
#include <seafire/protocol/response.hxx>

#include <seafire/common/io/stream.hxx>

#include <asio.hpp>

#include <cstddef>
#include <system_error>

namespace seafire::protocol
{

  void
  read(common::io::stream_t&,
       asio::streambuf&,
       request_t&);

  void
  read(common::io::stream_t&,
       asio::streambuf&,
       request_t&,
       std::error_code&);

  void
  async_read(common::io::stream_t&,
             asio::streambuf&,
             request_t&,
             std::function<void(std::error_code)>);

  void
  read(common::io::stream_t&,
       asio::streambuf&,
       response_t&);

  void
  read(common::io::stream_t&,
       asio::streambuf&,
       response_t&,
       std::error_code&);

  void
  async_read(common::io::stream_t&,
             asio::streambuf&,
             response_t&,
             std::function<void(std::error_code)>);

} // namespace seafire::protocol

#endif
