#ifndef seafire__protocol__write_hxx_
#define seafire__protocol__write_hxx_

#include <seafire/protocol/request.hxx>
#include <seafire/protocol/response.hxx>

#include <seafire/common/io/buffer.hxx>
#include <seafire/common/io/stream.hxx>

#include <asio.hpp>

#include <functional>
#include <system_error>

namespace seafire::protocol
{

  void
  write(common::io::stream_t&,
        request_t const&);

  void
  write(common::io::stream_t&,
        request_t const&,
        std::error_code&);

  void
  write(common::io::stream_t&,
        request_t const&,
        std::vector<common::io::const_buffer_t> const&);

  void
  write(common::io::stream_t&,
        request_t const&,
        std::vector<common::io::const_buffer_t> const&,
        std::error_code&);

  void
  async_write(common::io::stream_t&,
              request_t const&,
              std::function<void(std::error_code)>);

  void
  async_write(common::io::stream_t&,
              request_t const&,
              std::vector<common::io::const_buffer_t> const&,
              std::function<void(std::error_code)>);

  void
  write(common::io::stream_t&,
        response_t const&);

  void
  write(common::io::stream_t&,
        response_t const&,
        std::error_code&);

  void
  write(common::io::stream_t&,
        response_t const&,
        std::vector<common::io::const_buffer_t> const&);

  void
  write(common::io::stream_t&,
        response_t const&,
        std::vector<common::io::const_buffer_t> const&,
        std::error_code&);

  void
  async_write(common::io::stream_t&,
              response_t const&,
              std::function<void(std::error_code)>);

  void
  async_write(common::io::stream_t&,
              response_t const&,
              std::vector<common::io::const_buffer_t> const&,
              std::function<void(std::error_code)>);

} // namespace seafire::protocol

#endif
